/* ╔════════════════╦══════════════════════════╗
   ║    John Breaux ║    JohnBreaux@my.unt.edu ║
   ║ Gabriel Castro ║ GabrielCastro@my.unt.edu ║
   ║ Michael Laymon ║ MichaelLaymon@my.unt.edu ║
   ╠════════════════╩══════════════════════════╣
   ║  Created 2022-04-16   Updated 2022-04-23  ║
   ╚═══════════════════════════════════════════╝  */

#include <string>

#include "graph.hpp" // graph, Graph reduction/Knot detection

int main (int argc, char **argv) {
   //? Command line argument structure?
   //? Other flags? What other features should this have?
   if (argc < 2) return 1;
   std::string filename = argv[1];
   graph g;

   // Read from a file, and print the result
   int err = g.read (filename);
   if (err) {
      return err;
   }
   g.print ();
   // Graph reduction
   printf ("Graph is %s\n", g.reducible () ? "not reducible! Deadlock!" : "reducible! No deadlock!");
   // TODO: Knot detection
   // printf ("Graph is %s\n", g.knotted () ? "knotted! Deadlock!" : "not! No deadlock!");
   return 0;
}
